package com.usky.dxtop.controller.web;


import com.usky.dxtop.common.core.domain.AjaxResult;
import com.usky.dxtop.service.SysFileService;
import com.usky.dxtop.service.vo.SysFileQueryRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.Arrays;
import java.util.Date;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author yq
 * @since 2021-10-09
 */
@RestController
@RequestMapping("/sysFile")
public class SysFileController {

    @Autowired
    private SysFileService sysFileService;

    @PostMapping
    public AjaxResult uploadFile(
            @RequestParam(value = "files",required = false) MultipartFile[] multipartFiles,
            @RequestParam(value = "urls[]",required = false) String[] urls,
            @RequestParam("batchNo") String batchNo,
            @RequestParam("businessType") String businessType,
            @RequestParam(name = "uploadType", required = false) String uploadType,
            @RequestParam(name = "expireAt", required = false) Date expireAt) {
        com.usky.dxtop.model.SysFile sysFile = new com.usky.dxtop.model.SysFile();
        sysFile.setUploadType(uploadType);
        sysFile.setBusinessType(businessType);
        sysFile.setBatchNo(batchNo);
        sysFile.setExpriceAt(expireAt);
        sysFile.setFiles(Arrays.asList(multipartFiles));
        sysFile.setUrls(null != urls?Arrays.asList(urls):null);
        return AjaxResult.success(sysFileService.addFile(sysFile));
    }

    @PostMapping("getFile")
    public AjaxResult getFile(@RequestBody SysFileQueryRequest sysFileQueryRequest) {
        return AjaxResult.success(sysFileService.getFile(sysFileQueryRequest));
    }

    @GetMapping("/generateBatchNo")
    public AjaxResult generateBatchNo() {
        return AjaxResult.success(sysFileService.generateBatchNo());
    }

    @PostMapping("/active")
    public AjaxResult active(@RequestParam("batchNo") String batchNo,
                             @RequestParam(value = "ids[]",required = false) String[] ids){
        return AjaxResult.success(sysFileService.active(batchNo,Arrays.asList(ids)));
    }
}

